/*
  (C)2019 izumi@ieee.org, all rights reserved
*/

#define GEISTER_C

#define DEBUG 0
#define ReinforcementMode 0

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdbool.h>

#include "geister.h"
#include "geisterlib.h"
#include "geisterclient.h"
#include "Geisterdatabase.h"

/*----------------------------------------------------------------*/
int GstSetGhost(struct GstGameStr *s,int ri_num,char init_pt[71][9],float *win_rate){
  const char color[2]={GstRed, GstBlue};
  int c;
  float w[70];

  if(ReinforcementMode==1){
    for(int i=0;i<8;i++){
      if(init_pt[ri_num][i]=='R'){s->ghost[GstPly0][i].color=GstRed;}
      else{s->ghost[GstPly0][i].color=GstBlue;}
    }
  }else{
    for(int i=0;i<70;i++){
      w[i]=win_rate[i];
    }
    c=WeightedRandom(w,70);
    for(int i=0;i<8;i++){
      if(init_pt[c][i]=='R'){s->ghost[GstPly0][i].color=GstRed;}
      else{s->ghost[GstPly0][i].color=GstBlue;}
    }
  }
  
  return TRUE;
}


/*----------------------------------------------------------------*/
int GstOpeningStrategy(struct GstGameStr *s, struct GstActionStr *a,int port,int imitation){
  if(port==10000){
    int i,j,d,i0,d0,i1,d1,xPly0,yPly0,xPly1,yPly1;
    int capturable[8]={};
    float N=2.0,S=0.0,E=1.0,W=1.0;
    float p[4]={N,E,S,W};
    //float w[4]={2.0,1.0,0.0,1.0};
    struct GstActionStr *map;
    struct GstGhostStr *ghost;
  
    // set search offset randomly
    i0=random()%8; 
    d0=random()%4;
  
    // search the action that can capture enemy's ghost
    for (i=0;i<8;i++){
      i1=(i+i0)%8; 
      a->ghost = &(s->ghost[GstPly0][i1]);
      xPly0=a->ghost->x;
      yPly0=a->ghost->y;
      if(s->ghost[GstPly0][i1].state!=GstEscaped){}
  
      for(j=0;j<8;j++){
        xPly1=s->ghost[GstPly1][j].x;
        yPly1=s->ghost[GstPly1][j].y;

        if(xPly0==xPly1&&(yPly0-yPly1)==1){
          a->dir=GstNorth;
          return TRUE;
        }
        if((xPly0-xPly1)==1&&yPly0==yPly1){
          a->dir=GstWest;
          return TRUE;
        }
        if((xPly1-xPly0)==1&&yPly0==yPly1){
          a->dir=GstEast;
          return TRUE;
        }
        if(xPly0==xPly1&&(yPly1-yPly0)==1){
          a->dir=GstSouth;
          return TRUE;
        }
      } 
    }

    // Capture Strategy RF.
    int r=rand();
    if(r%12<9){ // move to north red ghost in frontline. 
      for(i=0;i<4;i++){
        i1=(i+i0)%4;
        a->ghost = &(s->ghost[GstPly0][i1]);
        a->dir=GstNorth;
        if(a->ghost->color==GstRed){
          if(!(a->ghost->y>=2&&s->board[a->ghost->x][a->ghost->y-2]!=NULL&&s->board[a->ghost->x][a->ghost->y-2]->player==GstPly1))
          if(!(a->ghost->y>=1&&a->ghost->x>=1&&s->board[a->ghost->x-1][a->ghost->y-1]!=NULL&&s->board[a->ghost->x-1][a->ghost->y-1]->player==GstPly1))
          if(!(a->ghost->y<=4&&a->ghost->x>=1&&s->board[a->ghost->x+1][a->ghost->y-1]!=NULL&&s->board[a->ghost->x+1][a->ghost->y-1]->player==GstPly1))
          {
            if (GstCheckAction(s,a)) return TRUE;
          }
        }
      }
    }else if(r%12<10){ // move to north blue ghost in frontline. 
      for(i=0;i<4;i++){
        i1=(i+i0)%4;
        a->ghost = &(s->ghost[GstPly0][i1]);
        a->dir=GstNorth;
        if(a->ghost->color==GstBlue){
          if(!(a->ghost->y>=2&&s->board[a->ghost->x][a->ghost->y-2]!=NULL&&s->board[a->ghost->x][a->ghost->y-2]->player==GstPly1))
          if(!(a->ghost->y>=1&&a->ghost->x>=1&&s->board[a->ghost->x-1][a->ghost->y-1]!=NULL&&s->board[a->ghost->x-1][a->ghost->y-1]->player==GstPly1))
          if(!(a->ghost->y<=4&&a->ghost->x>=1&&s->board[a->ghost->x+1][a->ghost->y-1]!=NULL&&s->board[a->ghost->x+1][a->ghost->y-1]->player==GstPly1))
          if (GstCheckAction(s,a)) return TRUE;
        }
      }
    }
    // select player's ghost randomly and move front 50% and left or right each 25%
    for (i=0;i<8;i++){
      i1=(i+i0)%8; 
      a->ghost = &(s->ghost[GstPly0][i1]);
      for(d=0;d<4;d++){
        d1=WeightedRandom(p,4);
        a->dir=d1;
        if (GstCheckAction(s,a)) return TRUE;
      }
    }

  }else{

    //move second
    if(imitation==TRUE){ // imitation strategy
      for(int i=0;i<8;i++){if(s->ghost[GstPly0][i].state!=GstCaptured&&s->ghost[GstPly1][i].state!=GstCaptured){
        if(s->ghost[GstPly0][i].x+s->ghost[GstPly1][i].x!=5){
          if(s->ghost[GstPly0][i].x+s->ghost[GstPly1][i].x==4){
            a->ghost=&(s->ghost[GstPly0][i]);
            a->dir=GstEast;
            break;
          }else{
            a->ghost=&(s->ghost[GstPly0][i]);
            a->dir=GstWest;
            break;
          }
        }
        if(s->ghost[GstPly0][i].y+s->ghost[GstPly1][i].y!=5){
          if(s->ghost[GstPly0][i].y+s->ghost[GstPly1][i].y==4){
            a->ghost=&(s->ghost[GstPly0][i]);
            a->dir=GstSouth;
            break;
          }else{
            a->ghost=&(s->ghost[GstPly0][i]);
            a->dir=GstNorth;
            break;
          }
        }
      }
      }
    }else{
      // Capture Strategy RF.
      int i,j,d,i0,d0,i1,d1,xPly0,yPly0,xPly1,yPly1;
      float N=2.0,S=0.0,E=1.0,W=1.0;
      float p[4]={N,E,S,W};

      // set search offset randomly
      i0=random()%8; 
      d0=random()%4;

      // search the action that can capture enemy's ghost
    for (i=0;i<8;i++){
      i1=(i+i0)%8; 
      a->ghost = &(s->ghost[GstPly0][i1]);
      xPly0=a->ghost->x;
      yPly0=a->ghost->y;
      if(s->ghost[GstPly0][i1].state!=GstEscaped){}
  
      for(j=0;j<8;j++){
        xPly1=s->ghost[GstPly1][j].x;
        yPly1=s->ghost[GstPly1][j].y;

        if(xPly0==xPly1&&(yPly0-yPly1)==1){
          a->dir=GstNorth;
          return TRUE;
        }
        if((xPly0-xPly1)==1&&yPly0==yPly1){
          a->dir=GstWest;
          return TRUE;
        }
        if((xPly1-xPly0)==1&&yPly0==yPly1){
          a->dir=GstEast;
          return TRUE;
        }
        if(xPly0==xPly1&&(yPly1-yPly0)==1){
          a->dir=GstSouth;
          return TRUE;
        }
      } 
    }

      int r=rand();

      if(r%12<9){ // move to north red ghost in frontline. 
        for(i=0;i<4;i++){
          i1=(i+i0)%4;
          a->ghost = &(s->ghost[GstPly0][i1]);
          a->dir=GstNorth;
          if(a->ghost->color==GstRed){
            if(!(a->ghost->y>=2&&s->board[a->ghost->x][a->ghost->y-2]!=NULL&&s->board[a->ghost->x][a->ghost->y-2]->player==GstPly1))
            if(!(a->ghost->y>=1&&a->ghost->x>=1&&s->board[a->ghost->x-1][a->ghost->y-1]!=NULL&&s->board[a->ghost->x-1][a->ghost->y-1]->player==GstPly1))
            if(!(a->ghost->y<=4&&a->ghost->x>=1&&s->board[a->ghost->x+1][a->ghost->y-1]!=NULL&&s->board[a->ghost->x+1][a->ghost->y-1]->player==GstPly1))
            if (GstCheckAction(s,a)) return TRUE;
          }
        }
      }else if(r%12<10){ // move to north blue ghost in frontline. 
        for(i=0;i<4;i++){
          i1=(i+i0)%4;
          a->ghost = &(s->ghost[GstPly0][i1]);
          a->dir=GstNorth;
          if(a->ghost->color==GstBlue){
            if(!(a->ghost->y>=2&&s->board[a->ghost->x][a->ghost->y-2]!=NULL&&s->board[a->ghost->x][a->ghost->y-2]->player==GstPly1))
            if(!(a->ghost->y>=1&&a->ghost->x>=1&&s->board[a->ghost->x-1][a->ghost->y-1]!=NULL&&s->board[a->ghost->x-1][a->ghost->y-1]->player==GstPly1))
            if(!(a->ghost->y<=4&&a->ghost->x>=1&&s->board[a->ghost->x+1][a->ghost->y-1]!=NULL&&s->board[a->ghost->x+1][a->ghost->y-1]->player==GstPly1))
            if (GstCheckAction(s,a)) return TRUE;
          }
        }
      }
      // select player's ghost randomly and move front 50% and left or right each 25%
      for (i=0;i<8;i++){
        i1=(i+i0)%8; 
        a->ghost = &(s->ghost[GstPly0][i1]);
        for(d=0;d<4;d++){
          d1=WeightedRandom(p,4);
          a->dir=d1;
          if (GstCheckAction(s,a)) return TRUE;
        }
      }

    }

  }
  
  return TRUE;
}


/*----------------------------------------------------------------*/
int GstPlay(struct GstGameStr *s, struct GstActionStr *a,struct GstPatternStr *b,double *passT,int port,int *color_inf,float *red_th,float *blue_th,float *confidence, struct GstActionStr *a_opp,int cap,int imitation){
  int i,j,d,i0,d0,i1,d1,x,y,xPly0,yPly0,xPly1,yPly1,move,diff;
  float w[4]={2.0,1.0,0.0,1.0};
  struct GstShortestStr dist[2][2]; // 2player*left,right


  // set search offset randomly
  i0=random()%8; 
  d0=random()%4;

  // search the ghost that can escape
  for(i=0;i<8;i++){
    if(s->ghost[GstPly0][i].y==0)
      if(s->ghost[GstPly0][i].x==0||s->ghost[GstPly0][i].x==5){
        a->ghost=&(s->ghost[GstPly0][i]);
        a->dir=GstNorth;
        if(GstCheckAction(s,a)) return TRUE;
      }
  }

  // search the victory pattern
  for(i=0;i<2;i++)
    for(j=0;j<2;j++)
      dist[i][j].ManhattanDist=99; // all pattern distance to exit set infinite value

  // search nearest ghost to each exit
  for(i=0;i<8;i++){
    x=s->ghost[GstPly1][i].x;
    y=s->ghost[GstPly1][i].y;
    if(x==-1) continue;
    if((x+y)<dist[GstPly1][GstWestExit].ManhattanDist){
      dist[GstPly1][GstWestExit].ManhattanDist=(x+y);
      dist[GstPly1][GstWestExit].ghost=&(s->ghost[GstPly1][i]);
    }
    if((5+y-x)<dist[GstPly1][GstEastExit].ManhattanDist){
      dist[GstPly1][GstEastExit].ManhattanDist=(5+y-x);
      dist[GstPly1][GstEastExit].ghost=&(s->ghost[GstPly1][i]);
    }
  }
  for(i=0;i<8;i++){ 
    x=s->ghost[GstPly0][i].x;
    y=s->ghost[GstPly0][i].y;
    if(x==-1) continue;
    if((x+y)<dist[GstPly0][GstWestExit].ManhattanDist){
      if(s->ghost[GstPly0][i].color==GstBlue){
        dist[GstPly0][GstWestExit].ManhattanDist=(x+y);
        dist[GstPly0][GstWestExit].ghost=&(s->ghost[GstPly0][i]);
        dist[GstPly0][GstWestExit].y=y;
      }
    }else
    if((5+y-x)<dist[GstPly0][GstEastExit].ManhattanDist){
      if(s->ghost[GstPly0][i].color==GstBlue){
        dist[GstPly0][GstEastExit].ManhattanDist=(5+y-x);
        dist[GstPly0][GstEastExit].ghost=&(s->ghost[GstPly0][i]);
        dist[GstPly0][GstEastExit].y=y;
      }
    }

    if((x+y)<dist[GstPly1][GstWestExit].ManhattanDist&&s->ghost[GstPly0][i].color==GstRed){
      s->ghost[GstPly0][i].hiddenTruth=FALSE;
    }else if((5+y-x)<dist[GstPly1][GstEastExit].ManhattanDist&&s->ghost[GstPly0][i].color==GstRed){
      s->ghost[GstPly0][i].hiddenTruth=FALSE;
    }else{
      if(s->ghost[GstPly0][i].hiddenTruth==FALSE){
        s->ghost[GstPly0][i].hiddenTruth==CapOnly;
      }
    }
  }
  
  // if AI's ghost can escape singularity, act to escape
  if(dist[GstPly0][GstWestExit].ManhattanDist<dist[GstPly1][GstWestExit].ManhattanDist){
    a->ghost=dist[GstPly0][GstWestExit].ghost;
    if(dist[GstPly0][GstWestExit].y==0){
      a->dir=GstWest;
      if (GstCheckAction(s,a)) return TRUE;
    }else{
      a->dir=GstNorth;
      if (GstCheckAction(s,a)) return TRUE;
    }
  }
  if(dist[GstPly0][GstEastExit].ManhattanDist<dist[GstPly1][GstEastExit].ManhattanDist){
    a->ghost=dist[GstPly0][GstEastExit].ghost;
    if(dist[GstPly0][GstEastExit].y==0){
      a->dir=GstEast;
      if (GstCheckAction(s,a)) return TRUE;
    }else{
      a->dir=GstNorth;
      if (GstCheckAction(s,a)) return TRUE;
    }
  } 
 
  // execute patternmatching
  if(GstPatternMatching(s,a,b)) return TRUE;

  // search effective action by using Mini-Max algorithm
  if(s->turn>8){
    if(s->turn<11){GstColorInference(s,TRUE,color_inf,red_th,blue_th,confidence,a_opp,cap);}
    else{GstColorInference(s,FALSE,color_inf,red_th,blue_th,confidence,a_opp,cap);}
    move=GstAlphaBeta(s,true,1,-999,999,passT,b,color_inf);
    printf(" move = %d \n",move);
    if(move==-99)goto xxx;
    a->ghost=&(s->ghost[GstPly0][move/10]);
    switch (move%10){
      case 0:{a->dir=GstWest;break;}
      case 1:{a->dir=GstEast;break;}
      case 2:{a->dir=GstNorth;break;}
      case 3:{a->dir=GstSouth;break;}
    }
    return TRUE;
  }else{
    GstColorInference(s,FALSE,color_inf,red_th,blue_th,confidence,a_opp,cap);
    if(GstOpeningStrategy(s,a,port,imitation)) return TRUE;
  } 

  xxx:

  // search the action that can capture enemy's ghost
  for (i=0;i<8;i++){
    i1=(i+i0)%8; 
    a->ghost = &(s->ghost[GstPly0][i1]);
    xPly0=s->ghost[GstPly0][i1].x;
    yPly0=s->ghost[GstPly0][i1].y;
  
    for(j=0;j<8;j++){
      xPly1=s->ghost[GstPly1][j].x;
      yPly1=s->ghost[GstPly1][j].y;

      for(d=0;d<4;d++){
        d1=(d+d0)%4;
        switch(d1){
          case 0:
          if(xPly0==xPly1&&yPly0-yPly1==1){
            a->dir=GstNorth;
            if (GstCheckAction(s,a))return TRUE;
          }break;
          case 1:
          if((xPly0-xPly1)==1&&yPly0==yPly1){
            a->dir=GstWest;
            if (GstCheckAction(s,a))return TRUE;
          }break;
          case 2:
          if((xPly1-xPly0)==1&&yPly0==yPly1){
            a->dir=GstEast;
            if (GstCheckAction(s,a))return TRUE;
          }break;
          case 3:
          if(xPly0==xPly1&&(yPly1-yPly0)==1){
            a->dir=GstSouth;
            if (GstCheckAction(s,a))return TRUE;
          }break;
        }
      }
    } 
  }

  // select player's ghost randomly and move front 50% and left or right each 25%
  for (i=0;i<8;i++){
    i1=(i+i0)%8; 
    a->ghost = &(s->ghost[GstPly0][i1]);
    for(d=0;d<4;d++){
      d1=WeightedRandom(w,4);
      a->dir=d1;
      if (GstCheckAction(s,a)) return TRUE;
    }
  }

  a->ghost=NULL;
  a->dir=-1;
  return FALSE;
}

/*----------------------------------------------------------------*/
int main(int argc, char **argv) {
  char *hostaddr=NULL, *hostport=NULL;
  int waittime,count_type,port,ri_num;
  double PassedTimeLog,*passT;
  struct GstGameStr gamestate, *s,gamestate_prev,*s_pre;
  struct GstActionStr action, *a,opponent_action,*a_opp;
  struct GstPatternStr Pt[NumPattern],*b;
  int r;
  int win_cnt1,win_cnt2,win_cnt3,win_cnt4,win_cnt5,win_cnt6,lose_cnt1,lose_cnt2,lose_cnt3,lose_cnt4,lose_cnt5,lose_cnt6;
  int game_num;
  double percent;
  char init_pattern[71][9];
 // char *init_pt=(char *)init_pattern;
  float win_rate[70];
  int win_num[70],lose_num[70];
  int color_inf[8];
  float red_th[8],blue_th[8],confidence[8];
  int cap=FALSE;
  int imitation=FALSE;
  // initialize threshold and confidence.
  for(int i=0;i<8;i++){
      red_th[i]=-1.0;
      blue_th[i]=1.0;
      confidence[i]=0.0;
      color_inf[i]=GstUnknown;
  }

  // process arguments
  printf("usage: %s [hostaddr] [hostport] [waittime]\n", argv[0]);
  if (argc<3) {
    fprintf(stderr,"Please give host addr and player turn\n");
    exit(1);
  }
  hostaddr = argv[1];
  hostport = argv[2];
  port=atoi(argv[2]);
  printf("host = %s:%s\n",hostaddr,hostport);
  waittime=(argc>=4)?atoi(argv[3]):0;
  if (waittime<0) waittime=0;
  printf("wait = %dsec\n",waittime);
  count_type=(argc>=5)?atoi(argv[4]):0;
  ri_num=(argc>=6)?atoi(argv[5]):0;

  // initialize the envirionments
  s=&gamestate;
  a=&action;
  s_pre=&gamestate_prev;
  a_opp=&opponent_action;
  b=Pt;
  passT=&PassedTimeLog;
  *passT=0;
  {time_t t;time(&t);srandom(t);}//set ramdom seed with current time
  if(count_type==1){
    if (!GstLogOpen2(&win_cnt1,&win_cnt2,&win_cnt3,&win_cnt4,&win_cnt5,&win_cnt6,&lose_cnt1,&lose_cnt2,&lose_cnt3,&lose_cnt4,&lose_cnt5,&lose_cnt6)) GstDie("unable to open log file");
    game_num=win_cnt1+win_cnt2+win_cnt3+win_cnt4+win_cnt5+win_cnt6+lose_cnt1+lose_cnt2+lose_cnt3+lose_cnt4+lose_cnt5+lose_cnt6;
  }else{
    //if (!GstLogOpen()) GstDie("unable to open log file");
  }
  if(!GstCsvOpen(init_pattern,win_rate,win_num,lose_num)) GstDie("unable to open csv file");
  r=GstConnectHost(hostaddr,hostport);
  if (!r) GstDie("unable to connect host");

  // if AI act second, choose imitation strategy in 50%.
  if(port==10001){
    if(rand()%2==0) imitation=TRUE;
  } 

  // example for logging
  //fprintf(gstlog,"Rits Geister\n");

  // starting the game
  GstInitGame(s);
  GstInitGame(s_pre);
  GstPatternSet(b); // read winning pattern
  GstSetGhost(s,ri_num,init_pattern,win_rate);
  GstPrintGame(stdout,s);
  GstSendGhostInfo(s);

  sleep(waittime);
  s->turn=(strncmp(hostport,"10000",5)==0)?0:1;

  while(1){ // main loop
    r=GstRecvBoardState(s);
    GstPrintGame(stdout,s);
    GstSearchPrevAction(s,s_pre,a_opp);

    if (r!=GstContinue) break;

    double PassedTime;
    clock_t start,end;
    start=clock();

    GstPlay(s,a,b,passT,port,color_inf,red_th,blue_th,confidence,a_opp,cap,imitation);

    end=clock();
    PassedTime=(double)(end-start)/CLOCKS_PER_SEC;
    printf("Used time for search is %.2fsec. \n",(double)(end-start)/CLOCKS_PER_SEC);
    *passT+=PassedTime;
    //GstPassedTimeLog((double)(end-start)/CLOCKS_PER_SEC,s->turn);

    cap=FALSE;
    if(a->dir==GstNorth){if(a->ghost->y!=0)if(s->board[a->ghost->x][a->ghost->y-1]!=NULL){if(s->board[a->ghost->x][a->ghost->y-1]->player==GstPly1)cap=TRUE;}}
    else if(a->dir==GstEast){if(a->ghost->x!=5)if(s->board[a->ghost->x+1][a->ghost->y]!=NULL){if(s->board[a->ghost->x+1][a->ghost->y]->player==GstPly1)cap=TRUE;}}
    else if(a->dir==GstSouth){if(a->ghost->y!=5)if(s->board[a->ghost->x][a->ghost->y+1]!=NULL){if(s->board[a->ghost->x][a->ghost->y+1]->player==GstPly1)cap=TRUE;}}
    else{if(a->ghost->x!=0)if(s->board[a->ghost->x-1][a->ghost->y]!=NULL){if(s->board[a->ghost->x-1][a->ghost->y]->player==GstPly1)cap=TRUE;}}

    GstCopyGame(s_pre,s,0);
    GstSendAction(a);
    GstExecAction(s,a);
    GstPrintGame(stdout,s);

    sleep(waittime);
  }

  if (r==GstWin){ 
    printf("I won the game!\n");
    if(port==10000){
      if(s->capturecount[GstPly1][GstBlue]==4) win_cnt1++;
      else if(s->capturecount[GstPly0][GstRed]==4) win_cnt2++;
      else win_cnt3++;
    }else{
      if(s->capturecount[GstPly1][GstBlue]==4) win_cnt4++;
      else if(s->capturecount[GstPly0][GstRed]==4) win_cnt5++;
      else win_cnt6++;
    }
  }
  else if (r==GstLose){
    printf("I lost the game!\n");
    if(port==10000){
      if(s->capturecount[GstPly0][GstBlue]==4) lose_cnt1++;
      else if(s->capturecount[GstPly1][GstRed]==4) lose_cnt2++;
      else lose_cnt3++;
    }else{
      if(s->capturecount[GstPly0][GstBlue]==4) lose_cnt4++;
      else if(s->capturecount[GstPly1][GstRed]==4) lose_cnt5++;
      else lose_cnt6++;
    }
  }
  else{ 
    printf("What's happen?\n");
  }

  printf("win=%d\nlose=%d\n",win_cnt1+win_cnt2+win_cnt3+win_cnt4+win_cnt5+win_cnt6,lose_cnt1+lose_cnt2+lose_cnt3+lose_cnt4+lose_cnt5+lose_cnt6);

  GstCloseHost();
  if(count_type==1) GstLogClose2(&win_cnt1,&win_cnt2,&win_cnt3,&win_cnt4,&win_cnt5,&win_cnt6,&lose_cnt1,&lose_cnt2,&lose_cnt3,&lose_cnt4,&lose_cnt5,&lose_cnt6,&game_num);
  //else GstLogClose(s->turn,*passT);
  if(ReinforcementMode==0)GstCsvClose();
  else GstCsvClose2(ri_num,r,init_pattern,win_rate,win_num,lose_num);

  return 0;
}

/*----------------------------------------------------------------*/
void GstDie(char *msg){
  fprintf(stderr,"%s\n",msg);
  GstCloseHost();
  GstLogClose(1,1);
  GstCsvClose();
  exit(1);
}
